# -*- coding: utf-8 -*-
import datetime

from odoo import api, models, modules
from odoo.addons.saas_worker import metabase


class AutoVacuum(models.AbstractModel):
    _inherit = 'ir.module.module'

    @api.autovacuum
    def _uninstall_fullstory(self):
        db = metabase.get(self._cr.dbname)
        fs = self.search([('name', '=', 'saas_fullstory')])
        if fs and fs.state == 'installed' and db and\
            db.create_date < datetime.datetime.now() - datetime.timedelta(hours=2):
            # button_immediate_uninstall() cannot be used directly because it will
            # try lock the ir_cron rows (SELECT * FROM ir_cron FOR UPDATE NOWAIT).
            # It will fail since the `autovacuum_job` cron is running and is thus already locking
            # its own row.
            # The code below is roughly the same used by button_immediate_uninstall
            # but without the lock on ir_cron. This should be pretty safe since
            # this module is just loading a js script and this file.
            fs.button_uninstall()
            self._cr.commit()
            if getattr(self._cr, 'reset', None):
                # 15.0+
                self._cr.reset()
            else:
                # before 15.0
                api.Environment.reset()
            modules.registry.Registry.new(self._cr.dbname, update_module=True)
